"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Utils_1 = require("./Utils");
describe('utils', () => {
    describe('interleave', () => {
        it('returns an empty array if passed an empty array', () => {
            const output = (0, Utils_1.interleave)([], () => ' ');
            expect(output).toEqual([]);
        });
        it('interleaves the separator into the array', () => {
            const output = (0, Utils_1.interleave)([1, 2, 3], () => ' ');
            expect(output).toEqual([1, ' ', 2, ' ', 3]);
        });
    });
    describe('groupBy', () => {
        const getFirstLetter = (str) => str.slice(0, 1);
        it('returns an empty object when given an empty array', () => {
            const groups = (0, Utils_1.groupBy)(getFirstLetter, []);
            expect(groups).toEqual({});
        });
        it('creates mappings of label to array matching it', () => {
            const groups = (0, Utils_1.groupBy)(getFirstLetter, ['abc', 'aaa', 'bcd']);
            expect(groups).toEqual({
                a: ['abc', 'aaa'],
                b: ['bcd'],
            });
        });
    });
});
