"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IconSwitch = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const react_native_reanimated_1 = __importStar(require("react-native-reanimated"));
const Icon_1 = require("../Icon/Icon");
const react_native_themes_1 = require("@brightlayer-ui/react-native-themes");
/**
 * This is a Switch component which allow us to show the check icon on ToggleOn and Close icon on ToggleOff Switch's handle.
 */
const IconSwitch = (props) => {
    const { showIcon = false, disabled = false, value = false, onValueChange, styles = {}, style, ...viewProps } = props;
    const theme = (0, react_native_themes_1.useExtendedTheme)(props.theme);
    const [toggled, setToggled] = (0, react_1.useState)(value);
    const shareValue = (0, react_native_reanimated_1.useSharedValue)(value ? 1 : 0);
    const onChangeToggle = () => {
        setToggled(!toggled);
        onValueChange?.(!toggled);
    };
    const onPressSwitch = () => {
        if (shareValue.value === 0) {
            shareValue.value = (0, react_native_reanimated_1.withTiming)(1, {
                duration: 100,
                easing: react_native_reanimated_1.Easing.bezier(0.4, 0.0, 0.2, 1),
            });
        }
        else {
            shareValue.value = (0, react_native_reanimated_1.withTiming)(0, {
                duration: 100,
                easing: react_native_reanimated_1.Easing.bezier(0.4, 0.0, 0.2, 1),
            });
        }
        onChangeToggle();
    };
    const defaultStyles = react_native_1.StyleSheet.create({
        track: {
            display: 'flex',
            justifyContent: 'center',
            height: 32,
            width: 52,
            backgroundColor: disabled
                ? theme.colors.sliderTrackDisabled
                : toggled
                    ? theme.colors.primary
                    : theme.colors.surfaceContainerHighest,
            borderColor: toggled ? undefined : disabled ? theme.colors.disabled : theme.colors.outline,
            borderWidth: toggled ? 0 : 2,
            borderRadius: 100,
        },
        handle: {
            display: 'flex',
            justifyContent: 'center',
            alignItems: 'center',
            width: toggled ? 24 : showIcon ? 24 : 16,
            height: toggled ? 24 : showIcon ? 24 : 16,
            borderRadius: 23,
            marginHorizontal: showIcon ? 2 : 6,
            backgroundColor: disabled
                ? toggled
                    ? theme.colors.surface
                    : theme.colors.onDisabledContainer
                : toggled
                    ? theme.colors.onPrimary
                    : theme.colors.onBackground,
        },
    });
    const rtl = react_native_1.I18nManager.isRTL;
    const toggleStyles = (0, react_native_reanimated_1.useAnimatedStyle)(() => ({
        transform: [
            {
                translateX: (0, react_native_reanimated_1.interpolate)(shareValue.value, [0, 1], showIcon ? (rtl ? [0, -22] : [0, 22]) : rtl ? [0, -18] : [0, 18], react_native_reanimated_1.Extrapolation.CLAMP),
            },
        ],
    }), []);
    return (react_1.default.createElement(react_native_1.TouchableOpacity, { disabled: disabled, onPress: onPressSwitch, activeOpacity: 1, style: [defaultStyles.track, styles.root, style], ...viewProps },
        react_1.default.createElement(react_native_reanimated_1.default.View, { style: [defaultStyles.handle, toggleStyles, styles.handle] }, showIcon && (react_1.default.createElement(react_1.default.Fragment, null, toggled ? (react_1.default.createElement(Icon_1.Icon, { source: { family: 'material', name: 'check' }, color: disabled ? theme.colors.disabled : theme.colors.onBackground, size: 16 })) : (react_1.default.createElement(Icon_1.Icon, { source: { family: 'material', name: 'close' }, color: disabled ? theme.colors.surfaceContainerHighest : theme.colors.onPrimary, size: 16 })))))));
};
exports.IconSwitch = IconSwitch;
